﻿;==========================================================================================================================================================
; Add a new category to the database
;==========================================================================================================================================================

Procedure EditCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PasswordMuncher_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> -1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PasswordMuncher_Category, Program\CurrentLine, Program\CategoryRecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentRecord
      
      ;--------------------------------------------------------------------------------------------
      ; Check if an existing window is opened
      ;--------------------------------------------------------------------------------------------
      
      If Program\WindowMutex <> 1
        
        ;------------------------------------------------------------------------------------------
        ; Try to open the data form window
        ;------------------------------------------------------------------------------------------
        
        If Window_Category()
          
          ;----------------------------------------------------------------------------------------
          ; Window was opened so set mutex to prevent other windows from opening
          ;----------------------------------------------------------------------------------------
          
          Program\WindowMutex = 1
          
          ;----------------------------------------------------------------------------------------
          ; Prevent user input on the main window
          ;----------------------------------------------------------------------------------------
          
          DisableWindow(#Window_PasswordMuncher, 1)
          
          ;----------------------------------------------------------------------------------------
          ; Add the hover gadgets to this window
          ;----------------------------------------------------------------------------------------
          
          AddHoverGadget(GadgetID(#Gadget_Category_Save))
          
          AddHoverGadget(GadgetID(#Gadget_Category_Exit))
          
          ;----------------------------------------------------------------------------------------
          ; Add the fast form close keyboard shortcut
          ;----------------------------------------------------------------------------------------
          
          AddKeyboardShortcut(#Window_Category, #PB_Shortcut_Escape,               #Shortcut_Category_Escape)
          
          AddKeyboardShortcut(#Window_Category, #PB_Shortcut_Alt | #PB_Shortcut_S, #Shortcut_Category_Save)
          
          AddKeyboardShortcut(#Window_Category, #PB_Shortcut_Alt | #PB_Shortcut_X, #Shortcut_Category_Exit)

          ;----------------------------------------------------------------------------------------
          ; Setup the common add window message
          ;----------------------------------------------------------------------------------------
          
          Message.s = "Edit An Old Category"
          
          ;----------------------------------------------------------------------------------------
          ; Set the last window message for the closure routine later
          ;----------------------------------------------------------------------------------------
          
          Program\LastWindow = Message.s
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the data window
          ;----------------------------------------------------------------------------------------
          
          SetWindowTitle(#Window_Category, Message.s)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\OldCategoryString = GetGadgetItemText(#Gadget_PasswordMuncher_Category, Program\CurrentLine, Program\CategoryItemColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Category_lCategory, "Edit (" + Program\OldCategoryString + ")")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Category_Category, Program\OldCategoryString)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_Category_RecordNumber, "Record No: " + GetGadgetItemText(#Gadget_PasswordMuncher_Category, Program\CurrentLine, Program\CategoryRecordColumn))
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the main window
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", Message.s)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the data form window is topmost
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_Category)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the version field is selected
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_Category_Category)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The ["  + Program\LastWindow + "] window could not be opened.")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn",  "The ["  + Program\LastWindow + "] program window is still open, close that one first.")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "There was no record number found on the selected line.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no category selected for editing.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 67
; FirstLine = 40
; Folding = -
; EnableXP
; HideErrorLog