﻿;==========================================================================================================================================================
; Load all the categories into the category bar
;==========================================================================================================================================================

Procedure LoadCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT * FROM Categories "
  
  QueryString.s + "ORDER BY Category ASC"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "All items",      ImageID(#CategoryEmpty))
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "Empty titles",   ImageID(#CategoryEmpty))
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "Favourites",     ImageID(#CategoryEmpty))
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "Locked items",   ImageID(#CategoryEmpty))
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "Deleted items",  ImageID(#CategoryEmpty))
    
    AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, "No category",    ImageID(#CategoryEmpty))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      passCategory.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
      
      passRecord.s    =           GetDatabaseString(Program\DatabaseHandle,   1) 
      
      AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, passCategory.s + Chr(10) + passRecord.s, ImageID(#CategoryStandard))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CountGadgetItems(#Gadget_PasswordMuncher_Category) <> 0
      
      SetActiveGadget(#Gadget_PasswordMuncher_Category)
      
      SetGadgetState(#Gadget_PasswordMuncher_Category, 0)
      
      SetGadgetItemState(#Gadget_PasswordMuncher_Category, 0, #PB_ListIcon_Selected)
      
      PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Category, #PB_EventType_LeftClick)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not retrieve categories from the database. " + DatabaseError())
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 34
; FirstLine = 11
; Folding = -
; EnableXP
; HideErrorLog