﻿;==========================================================================================================================================================
; Save the changed category data to the database
;==========================================================================================================================================================

Procedure SaveCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryString.s = RepQuote(GetGadgetText(#Gadget_Category_Category))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryString.s
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select Program\LastWindow
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Case  "Add A New Category"
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "INSERT INTO Categories(Category) "
        
        QueryString.s + "VALUES('" + CategoryString.s + "')"
        
        ;------------------------------------------------------------------------------------------
        ; Now update the database with the new record
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          ;----------------------------------------------------------------------------------------
          ; Get the new record number if any
          ;----------------------------------------------------------------------------------------
          
          NewRecordNumber.s = DatabaseLastInsertRowId()
          
          ;----------------------------------------------------------------------------------------
          ; Proceed if we got a record number
          ;----------------------------------------------------------------------------------------
          
          If NewRecordNumber.s
            
            ;--------------------------------------------------------------------------------------
            ; Display the new string of data
            ;--------------------------------------------------------------------------------------
            
            AddGadgetItem(#Gadget_PasswordMuncher_Category, -1, CategoryString.s + Chr(10) + NewRecordNumber.s, ImageID(#CategoryStandard))
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Database failed to be updated so we didn't get a new record number.")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError())
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case  "Edit An Old Category"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "UPDATE Categories "
        
        QueryString.s + "SET Category = '" + CategoryString.s + "' "
        
        QueryString.s + "WHERE Record = '" + Program\CurrentRecord + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          ;----------------------------------------------------------------------------------------
          ; Display the new or edited string of data
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_PasswordMuncher_Category, Program\CurrentLine, KillQuote(CategoryString.s), Program\CategoryItemColumn)
          
          ;----------------------------------------------------------------------------------------
          ; Create the main table category update
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE Passwords SET Category = '" + CategoryString.s + "' "
          
          QueryString.s + "WHERE Category = '"                + Program\OldCategoryString + "'"
          
          ;----------------------------------------------------------------------------------------
          ; Update main table when category string has changed
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
            SetInfoBarArea("Headings", "Info", "Categories updated in main database with new category.")
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Could no update categories in main database with new category.")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Tell the user about the new update
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", "Old record: " + Program\CurrentRecord + ", " + KillQuote(CategoryString.s) + " has been saved to the database.")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError())
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseMyWindow(#Window_Category)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SortCategoryEntries()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "The category string was empty, there is nothing to save.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 144
; FirstLine = 133
; Folding = -
; EnableXP
; HideErrorLog