﻿;==========================================================================================================================================================
; Show the  category selected in the category tree
;==========================================================================================================================================================

Procedure ShowCategory()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PasswordMuncher_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine <> -1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentCategory.s = GetGadgetItemText(#Gadget_PasswordMuncher_Category, CurrentLine.i, 0)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentCategory.s <> ""
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemText(#Gadget_PasswordMuncher_Titles, -1, ">> ", 0)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_PasswordMuncher_Titles)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_PasswordMuncher_Details, "")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select CurrentCategory.s
          
        ;------------------------------------------------------------------------------------------
          
        Case "All items"      ; Where the title isn't empty and isn't marked deleted
          
          QueryString.s = "SELECT * FROM Passwords WHERE Title <> '' AND Deleted <> '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Empty titles"   ; Where the title is empty and isn't marked deleted
          
          QueryString.s = "SELECT * FROM Passwords WHERE Title = '' AND Deleted = '0' "  
          
          ;----------------------------------------------------------------------------------------
          
        Case "Favourites"     ; Where the title isn't empty and the title is a favourite and isn't marked deleted
          
          QueryString.s = "SELECT * FROM Passwords WHERE Title <> '' AND Favourite = '1' AND Locked <> '1' AND Deleted = '0' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Locked items"   ; Where the title isn't empty and the title is locked and isn't marked deleted
          
          QueryString.s = "SELECT * FROM Passwords WHERE Title <> '' AND Locked = '1' AND Deleted <> '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "Deleted items"  ; Where is marked deleted
          
          QueryString.s = "SELECT * FROM Passwords WHERE Title <> '' AND Deleted = '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Case "No category"    ; Where an item has no category
          
          QueryString.s = "SELECT * FROM Passwords WHERE Category = '' AND Deleted <> '1' "
          
          ;----------------------------------------------------------------------------------------
          
        Default
          
          QueryString.s = "SELECT * FROM Passwords WHERE Category = '" + CurrentCategory.s + "' AND Deleted <> '1' "
          
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s + "ORDER BY Title ASC"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PseudoCounter.i = 0
      
      DeletedPseudoCounter.i = 0
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          Password\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0)) ;: Debug Password\Title
          
          Password\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1)) ;: Debug Password\Information
          
          Password\Category     =           GetDatabaseString(Program\DatabaseHandle, 2)  ;: Debug Password\Favourite
          
          Password\Favourite    =           GetDatabaseString(Program\DatabaseHandle, 3)  ;: Debug Password\Favourite
          
          Password\Locked       =           GetDatabaseString(Program\DatabaseHandle, 4)  ;: Debug Password\Favourite
          
          Password\Deleted      =           GetDatabaseString(Program\DatabaseHandle, 5)  ;: Debug Password\Deleted
          
          Password\Record       =           GetDatabaseString(Program\DatabaseHandle, 6)  ;: Debug Password\Record
          
          If Password\Deleted  = "1"
            
            DeletedPseudoCounter.i +1
            
          EndIf
          
          DisplayTitleString(PseudoCounter.i, "AddMode")
          
          PseudoCounter.i + 1
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Category, -1, ">> " + CurrentCategory.s, 0)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If PseudoCounter.i = 0 And DeletedPseudoCounter.i = 0
          
          SetGadgetItemText(#Gadget_PasswordMuncher_Titles, -1, ">> No items in [" + CurrentCategory.s + "]", 0)
          
        Else
          
          SetGadgetItemText(#Gadget_PasswordMuncher_Titles, -1, ">> " + Str(DeletedPseudoCounter.i) + " items in [" + CurrentCategory.s + "]", 0)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", "", Str(PseudoCounter.i))
        
        ;------------------------------------------------------------------------------------------
        ; Scroll the last line into view
        ;------------------------------------------------------------------------------------------
        
;       SetActiveGadget(#Gadget_PasswordMuncher_Titles)
        
        PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Titles, #PB_EventType_Change)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetItemState(#Gadget_PasswordMuncher_Titles, PseudoCounter.i -1, #PB_ListIcon_Selected)
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", "", Str(CountGadgetItems(#Gadget_PasswordMuncher_Titles)))
        
        ;--------------------------------------------------------------------------------------
        ; 
        ;--------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty " + DatabaseError())
        
      EndIf
      
      ;----------------------------------------------------------------------------------------
      ; 
      ;----------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Info",  "No category string was found on that line.")
      
    EndIf
    
    ;------------------------------------------------------------------------------------------
    ; 
    ;------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "There is no current line selected.")
    
  EndIf
  
  ;--------------------------------------------------------------------------------------------
  ; 
  ;--------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 88
; FirstLine = 62
; Folding = -
; EnableXP
; HideErrorLog