﻿;==========================================================================================================================================================
; Fade the window out gently, close it and reset the mutex
;==========================================================================================================================================================

Procedure CloseMyWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the current line number
  ;------------------------------------------------------------------------------------------------
  
  FocusLine.i = Program\CurrentLine
  
  ;------------------------------------------------------------------------------------------------
  ; Remove hover events for windows
  ;------------------------------------------------------------------------------------------------
  
  Select Window.i
      
      ;--------------------------------------------------------------------------------------------
      ; Appointment data window
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Data
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_Save))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_Export))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_Import))
      
      RemoveHoverGadget(GadgetID(#Gadget_Data_Exit))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  #Window_Category
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(GadgetID(#Gadget_Category_Save))
      
      RemoveHoverGadget(GadgetID(#Gadget_Category_Exit))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Close the form window if it is not the master window
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Tell the user what just happened
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings",  "Info", "Window (" + Program\LastWindow + ") closed.")
  
  ;------------------------------------------------------------------------------------------------
  ; Zero certain variables not from the main window when they are closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_PasswordMuncher
    
    ;----------------------------------------------------------------------------------------------
    ; Clear necessary variables
    ;----------------------------------------------------------------------------------------------
    
    Program\WindowMutex     =  0                                                                    ; Make sure other windows can open now  
    
    Program\CurrentLine     = -1                                                                    ; Make sure no line can be selected accidentally
    
    Program\CurrentRecord   = ""                                                                    ; Nullify the current record number to avoid mistakes
    
    Program\LastWindow      = ""                                                                    ; Clear last used windows state
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Refocus on main window and current record when data window is closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_PasswordMuncher
    
    DisableWindow(#Window_PasswordMuncher, #False)
    
    HideWindow(#Window_PasswordMuncher, #False)
    
    SetActiveWindow(#Window_PasswordMuncher)
    
    SetActiveGadget(#Gadget_PasswordMuncher_Titles)
    
    If FocusLine.i <> 0
      
      SetGadgetState(#Gadget_PasswordMuncher_Titles, FocusLine.i)
      
    Else
      
      FocusLine.i = CountGadgetItems(#Gadget_PasswordMuncher_Titles) - 1
      
    EndIf
   
    PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Titles, #PB_EventType_Change)

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 32
; FirstLine = 19
; Folding = -
; EnableXP
; HideErrorLog