﻿;==========================================================================================================================================================
; Mark the selected item as deleted
;==========================================================================================================================================================

Procedure DeleteCurrentData()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PasswordMuncher_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> -1
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    passTitle.s           = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\TitleColumn)
    
    passCategory.s        = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\CategoryColumn)
    
    passFavourite.s       = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\FavouriteColumn)
    
    passLocked.s          = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\LockedColumn)
    
    passDeleted.s         = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\DeletedColumn)
    
    passRecord.s          = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passLocked.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
      If  passDeleted.s = "0"
        
        passDeleted.s = "1"
        
      ElseIf  passDeleted.s = "1"
        
        passDeleted.s = "0"
        
      EndIf
        
      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a record number
      ;--------------------------------------------------------------------------------------------
      
      If passRecord.s <> ""
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "UPDATE Passwords "
        
        QueryString.s + "SET Deleted = '"   + passDeleted.s + "' "
        
        QueryString.s + "WHERE Record = '"  + passRecord.s  + "'"
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemData(#Gadget_PasswordMuncher_Titles,  CurrentLine.i, Val(passDeleted.s))
          
          RedrawWindow_(GadgetID(#Gadget_PasswordMuncher_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If passLocked.s = "1"
            
            ChangeIcon(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\TitleColumn, Icon\ListLocked)
            
          ElseIf  passLocked.s <> "1"
            
            If passDeleted.s = "1"
              
              SetGadgetItemData(#Gadget_PasswordMuncher_Titles,  CurrentLine.i, Val(passDeleted.s))
              
              RedrawWindow_(GadgetID(#Gadget_PasswordMuncher_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
              
              ChangeIcon(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\TitleColumn, Icon\ListDeleted)
              
              RemoveGadgetItem(#Gadget_PasswordMuncher_Titles, CurrentLine.i)   ; Requested by Dee
              
            ElseIf passDeleted.s <> "1"
              
              If passFavourite.s = "1"
                
                ChangeIcon(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\TitleColumn, Icon\ListFavourite)
                
              ElseIf passFavourite.s <> "1"
                
                ChangeIcon(#Gadget_PasswordMuncher_Titles, CurrentLine.i, Program\TitleColumn, Icon\ListNormal)
                
              EndIf
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_PasswordMuncher_Titles,  CurrentLine.i, passDeleted.s, Program\DeletedColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError())
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "No record number found for line " + Str(CurrentLine.i))
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Info", "Cannot delete this record, it is currently locked.")
      
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "There is no current line selected.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 102
; FirstLine = 83
; Folding = -
; EnableXP
; HideErrorLog