﻿;==========================================================================================================================================================
; Handle all list display jobs from add, edit, list, import modes etc
;==========================================================================================================================================================

Procedure DisplayTitleString(LineNumber.i, DisplayMode.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case  "AddMode"
    
      ;--------------------------------------------------------------------------------------------
      ; Add appointments to the list
      ;--------------------------------------------------------------------------------------------
      
      With Password
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        TitleString.s       =  \Title        + Chr(10)
        
        CategoryString.s    =  \Category     + Chr(10)
        
;       InformationString.s =  \Information  + Chr(10)
        
        FavouriteString.s   =  \Favourite    + Chr(10)

        LockedString.s      =  \Locked       + Chr(10)
        
        DeletedString.s     =  \Deleted      + Chr(10)
        
        RecordString.s      =  \Record
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ListString.s        = TitleString.s   + CategoryString.s  + FavouriteString.s
        
        ListString.s        + LockedString.s  + DeletedString.s   + RecordString.s

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        AddGadgetItem(#Gadget_PasswordMuncher_Titles, -1,  KillQuote(ListString.s))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ListString.s = ""
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndWith
      
      ;--------------------------------------------------------------------------------------------
      ; Update columns in the list for an edited record
      ;--------------------------------------------------------------------------------------------
      
    Case  "EditMode"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      With Password
        
        ;------------------------------------------------------------------------------------------
        ; Update the details in the list for the selected record
        ;------------------------------------------------------------------------------------------
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i, KillQuote(\Title),         Program\TitleColumn)
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i, KillQuote(\Category),      Program\CategoryColumn)
        
;       SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i, KillQuote(\Information),   Program\InformationColumn)
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i,           \Favourite ,     Program\FavouriteColumn)

        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i,           \Locked,         Program\LockedColumn)
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i,           \Deleted,        Program\DeletedColumn)
        
        SetGadgetItemText(#Gadget_PasswordMuncher_Titles, LineNumber.i,           \Record,         Program\RecordColumn)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndWith
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Password\Locked = "1"
    
    ChangeIcon(#Gadget_PasswordMuncher_Titles, LineNumber.i, Program\TitleColumn, Icon\ListLocked)
    
  ElseIf  Password\Locked <> "1"
    
    If Password\Deleted = "1"
      
      SetGadgetItemData(#Gadget_PasswordMuncher_Titles,  LineNumber.i, Val(Password\Deleted))
      
      RedrawWindow_(GadgetID(#Gadget_PasswordMuncher_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
      
      ChangeIcon(#Gadget_PasswordMuncher_Titles, LineNumber.i, Program\TitleColumn, Icon\ListDeleted)
      
    ElseIf Password\Deleted <> "1"
      
      If Password\Favourite = "1"
        
        ChangeIcon(#Gadget_PasswordMuncher_Titles, LineNumber.i, Program\TitleColumn, Icon\ListFavourite)
        
      ElseIf Password\Favourite <> "1"
        
        ChangeIcon(#Gadget_PasswordMuncher_Titles, LineNumber.i, Program\TitleColumn, Icon\ListNormal)
        
      EndIf
      
    EndIf
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 102
; FirstLine = 102
; Folding = -
; EnableXP