﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure EditOldData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PasswordMuncher_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> -1
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, Program\CurrentLine, Program\RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    passLocked.s  = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, Program\CurrentLine, Program\LockedColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If passLocked.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      passDeleted.s = GetGadgetItemText(#Gadget_PasswordMuncher_Titles, Program\CurrentLine, Program\DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If passDeleted.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Program\CurrentRecord <> ""
          
          ;----------------------------------------------------------------------------------------
          ; Check if a previous window is open
          ;----------------------------------------------------------------------------------------
          
          If Program\WindowMutex <> 1
            
            ;--------------------------------------------------------------------------------------
            ; Try to open the data window
            ;--------------------------------------------------------------------------------------
            
            If Window_Data()
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetWindowCallback(@DataWindowCallback(), #Window_Data)
              
              ;------------------------------------------------------------------------------------
              ; Prevent user input on the main window
              ;------------------------------------------------------------------------------------
              
              DisableWindow(#Window_PasswordMuncher, #True)
              
              ;------------------------------------------------------------------------------------
              ; Warn other components a window is open and not to attempt to open another
              ;------------------------------------------------------------------------------------
              
              Program\WindowMutex = 1
              
              ;------------------------------------------------------------------------------------
              ; Add the various keyboard shortcuts
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Escape, #Shortcut_Data_Escape)
              
              ;------------------------------------------------------------------------------------
              ; Add keyboard shortcuts as backup to the buttons, Good for people with sore mouse wrists
              ;------------------------------------------------------------------------------------
            
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_B,    #Shortcut_Data_Bold)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_U,    #Shortcut_Data_Underline)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_I,    #Shortcut_Data_Italic)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_S,    #Shortcut_Data_Strikeout)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_A,    #Shortcut_Data_Subscript)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_D,    #Shortcut_Data_Superscript)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_L,    #Shortcut_Data_Link)
            
              ;------------------------------------------------------------------------------------
              ; Make the selected font grow or shrink
              ;------------------------------------------------------------------------------------
            
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_Up,   #Shortcut_Data_FontUp)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Control | #PB_Shortcut_Down, #Shortcut_Data_FontDown)
              
              ;------------------------------------------------------------------------------------
              ; Fast exit from the program
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Alt     | #PB_Shortcut_S,   #Shortcut_Data_Save)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Alt     | #PB_Shortcut_I,   #Shortcut_Data_Import)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Alt     | #PB_Shortcut_E,   #Shortcut_Data_Export)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Alt     | #PB_Shortcut_L,   #Shortcut_Data_Search)
              
              AddKeyboardShortcut(#Window_Data, #PB_Shortcut_Alt     | #PB_Shortcut_X,   #Shortcut_Data_Exit)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddHoverGadget(GadgetID(#Gadget_Data_Save))
              
              AddHoverGadget(GadgetID(#Gadget_Data_Export))
              
              AddHoverGadget(GadgetID(#Gadget_Data_Import))

              AddHoverGadget(GadgetID(#Gadget_Data_Exit))
              
              ;------------------------------------------------------------------------------------
              ; Remove theme support from the comment box or it retains a border even when API removed
              ;------------------------------------------------------------------------------------
              
              SetWindowTheme_(GadgetID(#Gadget_Data_Details),   @null.w, @null.w)
              
              ;------------------------------------------------------------------------------------------------
              ; Allow the editorgadget to send back event messages. Sparkie/Srod
              ;------------------------------------------------------------------------------------------------
              
              CurrentFlags.l = SendMessage_(GadgetID(#Gadget_Data_Details), #EM_GETEVENTMASK, 0, 0)
              
              SendMessage_(GadgetID(#Gadget_Data_Details), #EM_SETEVENTMASK, 0, #ENM_MOUSEEVENTS | #ENM_CHANGE | CurrentFlags) 
              
              ;------------------------------------------------------------------------------------------------
              ; FluidByte routine. Set ownerdrawn combo box's item height
              ;------------------------------------------------------------------------------------------------
              
              SendMessage_(GadgetID(#Gadget_Data_font), #CB_SETITEMHEIGHT, 0, 20)
              
              ;------------------------------------------------------------------------------------------------
              ; FluidByte routine. Find all the fonts in the system
              ;------------------------------------------------------------------------------------------------
              
              EnumFonts(#Gadget_Data_font)
              
              ;------------------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------------------
              
              SetGadgetState(#Gadget_Data_font, 0)
              
              ;------------------------------------------------------------------------------------------------
              ; Add the standard font sizes to the size selector
              ;------------------------------------------------------------------------------------------------
              
              Restore BeginFontSizes
              
              While TempFontsizes.s <> "_EndFontSizes_"
                
                Read.s TempFontsizes.s
                
                If TempFontsizes.s <> "_EndFontSizes_"
                  
                  AddGadgetItem(#Gadget_Data_size, -1, TempFontsizes.s)
                  
                EndIf
                
              Wend
              
              TempFontsize.s    = "<>"
              
              ;------------------------------------------------------------------------------------------------
              ; Make the first font in the list visible
              ;------------------------------------------------------------------------------------------------
              
              SetGadgetState(#Gadget_Data_size, 0)
              
              ;------------------------------------------------------------------------------------------------
              ; Add the standard regional character sets to the selector (Not used yet)
              ;------------------------------------------------------------------------------------------------
              
              Restore BeginCharacterArea
              
              While TempCharacterArea.s <> "_EndCharacterArea_"
                
                Read.s TempCharacterArea.s
                
                If TempCharacterArea.s <> "_EndCharacterArea_"
                  
                  AddGadgetItem(#Gadget_Data_character, -1, TempCharacterArea.s)
                  
                EndIf
                
              Wend
              
              TempFontsize.s    = "<>"
              
              ;------------------------------------------------------------------------------------------------
              ; Make the western character set the default visible one (not used yet)
              ;------------------------------------------------------------------------------------------------
              
              SetGadgetState(#Gadget_Data_character, 8)
              
              ;------------------------------------------------------------------------------------
              ; Set the common window and statusbar message
              ;------------------------------------------------------------------------------------
              
              Message.s = "Edit Old PasswordMuncher Item"
              
              ;------------------------------------------------------------------------------------
              ; Use the common message as a window identifier
              ;------------------------------------------------------------------------------------
              
              Program\LastWindow = Message.s
              
              ;------------------------------------------------------------------------------------
              ; Set the window title with the common message and next record number
              ;------------------------------------------------------------------------------------
              
              SetWindowTitle(#Window_Data, Message.s + "   --   Record number: " + Program\CurrentRecord)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_Data_cCategory, -1, "", ImageID(#CategoryStandard))
      
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              QueryString.s = "SELECT * FROM Categories "
              
              QueryString.s + "ORDER BY Category"
              
              If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  passCategory.s    = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
                  
                  AddGadgetItem(#Gadget_Data_cCategory, -1, passCategory.s, ImageID(#CategoryStandard))
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              QueryString.s = "SELECT * FROM Passwords "
              
              QueryString.s + "WHERE Record = '"  + Program\CurrentRecord + "'"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  Password\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
                  
                  Password\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1))
                  
                  Password\Category     = KillQuote(GetDatabaseString(Program\DatabaseHandle, 2))
                  
                  Password\Favourite    = KillQuote(GetDatabaseString(Program\DatabaseHandle, 3)) 
                  
                  Password\Locked       = KillQuote(GetDatabaseString(Program\DatabaseHandle, 4)) 
                  
                  Password\Deleted      = KillQuote(GetDatabaseString(Program\DatabaseHandle, 5))
                  
                  Password\Record       = KillQuote(GetDatabaseString(Program\DatabaseHandle, 6))
                  
                Wend
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
              Else
                
                SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty.")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SetGadgetText(#Gadget_Data_Title,         Password\Title)
              
              SetGadgetText(#Gadget_Data_Details,       Password\Information)
              
              If Password\Category <> ""
                
                SetGadgetText(#Gadget_Data_cCategory, Password\Category)
                
              Else
                
                SetGadgetState(#Gadget_Data_cCategory, 0)
                
              EndIf
              
              SetGadgetText(#Gadget_Data_Recordnumber,  Password\Record)
        
              ;------------------------------------------------------------------------------------
              ; Set the current operation details on the the main window status bar
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings",  "Info",  Message.s + "   --   Record number: " + Str(NextRecord.i) + " ?")
              
              ;------------------------------------------------------------------------------------
              ; Set focus on the appointment name field
              ;------------------------------------------------------------------------------------
              
              SetActiveGadget(#Gadget_Data_Title)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  "Could not open the [" + Program\LastWindow  + "] window.")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Warn",  "The [" + Program\LastWindow + "] window is still open, close that one first.")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "There was no record number found for the selected line.")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings",  "Warn",  "Cannot edit a deleted record, recover it first.")
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot edit this record, it is currently locked.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "There is no current line selected.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 126
; FirstLine = 123
; Folding = -
; EnableXP
; HideErrorLog