﻿;==========================================================================================================================================================
; Show all the items in the database
;==========================================================================================================================================================

Procedure SearchPasswords()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchField.s = GetGadgetText(#Gadget_PasswordMuncher_Searchfield)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchText.s  = GetGadgetText(#Gadget_PasswordMuncher_Searchstring)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(#Gadget_PasswordMuncher_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_PasswordMuncher_Details, "")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\FirstTime = 0
    
    Program\FirstTime = 1
    
    QueryString.s = "SELECT * FROM Passwords "     ; Show all fields regardless of search
    
    QueryString.s + "WHERE Title <> '' "
    
    QueryString.s + "AND Deleted <> '1' "
    
    QueryString.s + "ORDER BY Title ASC"
    
  Else
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select  SearchField.s
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Case "All fields"
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "SELECT * FROM Passwords "
        
        QueryString.s + "WHERE Title LIKE '%"     + SearchText.s  + "%' " 
        
        QueryString.s + "OR Information LIKE '%"  + SearchText.s  + "%' " 
        
        QueryString.s + "OR Category LIKE '%"     + SearchText.s  + "%' " 
        
        QueryString.s + "OR Favourite LIKE '%"    + SearchText.s  + "%' " 
        
        QueryString.s + "OR Locked LIKE '%"       + SearchText.s  + "%' " 
        
        QueryString.s + "OR Deleted LIKE '%"      + SearchText.s  + "%' " 
        
        QueryString.s + "OR Record LIKE '%"       + SearchText.s  + "%' "
        
        QueryString.s + "AND Deleted <> '1' "
        
        QueryString.s + "ORDER BY Title ASC"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Default
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "SELECT * FROM Passwords "
        
        QueryString.s + "WHERE '"   + SearchField.s + "' "
        
        QueryString.s + "LIKE '%"   + SearchText.s  + "%' "
        
        QueryString.s + "AND Title <> '' "
        
        QueryString.s + "AND Deleted <> '1' "
        
        QueryString.s + "ORDER BY Title ASC"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndIf
    
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PseudoCounter.i = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      Password\Title        = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0)) ;: Debug Password\Title
      
      Password\Information  = KillQuote(GetDatabaseString(Program\DatabaseHandle, 1)) ;: Debug Password\Information
      
      Password\Category     =           GetDatabaseString(Program\DatabaseHandle, 2)  ;: Debug Password\Favourite
      
      Password\Favourite    =           GetDatabaseString(Program\DatabaseHandle, 3)  ;: Debug Password\Favourite
      
      Password\Locked       =           GetDatabaseString(Program\DatabaseHandle, 4)  ;: Debug Password\Favourite
      
      Password\Deleted      =           GetDatabaseString(Program\DatabaseHandle, 5)  ;: Debug Password\Deleted
      
      Password\Record       =           GetDatabaseString(Program\DatabaseHandle, 6)  ;: Debug Password\Record
      
      DisplayTitleString(PseudoCounter.i, "AddMode")
      
      PseudoCounter.i + 1
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", "", Str(PseudoCounter.i))
    
    ;----------------------------------------------------------------------------------------------
    ; Scroll the last line into view
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_PasswordMuncher_Titles)
    
    PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Titles, #PB_EventType_Change)
    
    SetGadgetItemState(#Gadget_PasswordMuncher_Titles, PseudoCounter.i -1, #PB_ListIcon_Selected)
    
    ;------------------------------------------------------------------------------------------------
    ; 
    ;------------------------------------------------------------------------------------------------
    
    SetInfoBarArea("Records", "", Str(CountGadgetItems(#Gadget_PasswordMuncher_Titles)))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty " + DatabaseError())
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;"All fields"
;"Title"
;"Information"
;"Category"
;"Favourite"
;"Locked"
;"Deleted"
;"Record"

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 123
; FirstLine = 144
; Folding = -
; EnableXP
; HideErrorLog