﻿;==========================================================================================================================================================
; Clean all deleted items from the database immediately
;==========================================================================================================================================================

Procedure VacuumDeletedData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Message.s = "Are you sure that you want to"         + Chr(10) + Chr(13)
  
  Message.s + "Permanently remove all passwords"      + Chr(10) + Chr(13)  
  
  Message.s + "marked as deleted from the database?"  + Chr(10) + Chr(13)  + Chr(10) + Chr(13)
  
  Message.s + "There is no way to recover from "      + Chr(10) + Chr(13)
  
  Message.s + "this procedure!!!"

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MessageRequester("Permanent removal", Message.s, #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    If MessageRequester("Are you sure?", "This is your last chance!!", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "DELETE FROM Passwords "
      
      QueryString.s + "WHERE Deleted = '1'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        NumberOfItems.i = CountGadgetItems(#Gadget_PasswordMuncher_Titles)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If NumberOfItems.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          For ListProcess.i = NumberOfItems.i To 0 Step -1
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If GetGadgetItemText(#Gadget_PasswordMuncher_Titles, ListProcess.i, Program\DeletedColumn) = "1"
            
              RemoveGadgetItem(#Gadget_PasswordMuncher_Titles, ListProcess.i)
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Next ListProcess.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          ; No items in the list to process  
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        ; Could not remove the records from the database
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ; User answered a firm to to continuing
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; User answered no to the permanent removal
    
  EndIf
    
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 99
; FirstLine = 74
; Folding = -
; EnableXP