;============================================================================================================================================================
; Count the number of records in an SQLite database
;============================================================================================================================================================

Procedure.s CountRecords(TableField.s, TableName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Query.s + "Select COUNT(" + TableField.s + ") AS totalrecs FROM " + TableName.s + ""
  
  ;------------------------------------------------------------------------------------------------
  ; Get the count of the records in the database
  ;------------------------------------------------------------------------------------------------

  If DatabaseQuery(Program\DatabaseHandle, Query.s)
    
    If FirstDatabaseRow(Program\DatabaseHandle)
        
      NumRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf
      
    FinishDatabaseQuery(Program\DatabaseHandle)
  
  Else
    
    NumRecords.s = "0"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn NumRecords.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure



; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; Folding = -
; DisableDebugger
; HideErrorLog