﻿;==========================================================================================================================================================
; Try to open the system database and create missing tables
;==========================================================================================================================================================

Procedure OpenSystemDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FileHandle.i = OpenFile(#PB_Any, Program\DatabaseName)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If FileHandle.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(FileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DatabaseHandle = OpenDatabase(#PB_Any, Program\DatabaseName, "", "")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\DatabaseHandle
      
      QueryString.s = "PRAGMA auto_vacuum = on"
      
      ; Turn on auto database vacuum
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Vacuum setup error", "Could not setup auto database vacuum.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Write the appointments table out
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Passwords("
      
      QueryString.s + "Title TEXT, Information TEXT, Category TEXT, Favourite TEXT, Locked TEXT, "
      
      QueryString.s + "Deleted TEXT, "
      
      QueryString.s + "Record INTEGER PRIMARY KEY AUTOINCREMENT)"
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Table creation error", "Could not create tables in database.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Write the appointments table out
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Categories("
      
      QueryString.s + "Category TEXT, "
      
      QueryString.s + "Record INTEGER PRIMARY KEY AUTOINCREMENT, "
      
      QueryString.s + "UNIQUE(Category))"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Table creation error", "Could not create tables in database.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Preferences("
      
      QueryString.s + "MD5FingerPrint TEXT, LastSearch TEXT, "
      
      QueryString.s + "Record INTEGER PRIMARY KEY AUTOINCREMENT)"
      
      If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        If CountRecords("Record", "Preferences") = "0"
          
          QueryString.s = "INSERT INTO Preferences("
          
          QueryString.s + "MD5FingerPrint, LastSearch) "
          
          QueryString.s + "VALUES("
          
          QueryString.s + "'', '')"
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
          Else
            
            Debug DatabaseError()
            
          EndIf
          
        EndIf
        
      Else
        
        MessageRequester("Table creation error", "Could not create table in database.")
        
        ProcedureReturn
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      MessageRequester("Database open error", "There was a serious problem attempting to connect to the system database. Could be corrupt or open by some other process. Exit Hive and try again.", #PB_MessageRequester_Ok)
      
      ProcedureReturn
      
    EndIf 
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    MessageRequester("Database file open error", "Could not open or create raw database file.", #PB_MessageRequester_Ok)
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; Folding = -
; EnableXP