﻿;========================================================================================================================================
; Show an RTF help file loaded into this window
;========================================================================================================================================

Procedure HelpForPasswords()
  
  ;----------------------------------------------------------------------------------------------
  ; See if there is another window open still
  ;----------------------------------------------------------------------------------------------
  
  If Program\WindowMutex = 0
    
    ;--------------------------------------------------------------------------------------------
    ; Attempt to open the module window
    ;--------------------------------------------------------------------------------------------
    
    If Window_Help()
      
      ;------------------------------------------------------------------------------------------
      ; Set the window check flag so no others will open
      ;------------------------------------------------------------------------------------------
      
      Program\WindowMutex = 1
      
      ;------------------------------------------------------------------------------------------
      ; Disable the main window
      ;------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_PasswordMuncher, 1)
      
      ;------------------------------------------------------------------------------------------
      ; Set the last window (and title message) string
      ;------------------------------------------------------------------------------------------
      
      Program\LastWindow = "Help for " + #Program
      
      ;------------------------------------------------------------------------------------------
      ; Set the window title here
      ;------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_Help, Program\LastWindow)
      
      ;------------------------------------------------------------------------------------------
      ; Remove editorgadget borders
      ;------------------------------------------------------------------------------------------
      
      RemoveBorders(#Gadget_Help_HelpPage)
      
      ;------------------------------------------------------------------------------------------
      ; Add the various keyboard shortcuts
      ;------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_Help, #PB_Shortcut_Escape, #Shortcut_Help_Escape)
      
      ;------------------------------------------------------------------------------------------
      ; Stream the RTF 'about' data into the note area from the data section
      ;------------------------------------------------------------------------------------------
      
      CatchRTF(#Gadget_Help_HelpPage, ?_Help)
      
      ;------------------------------------------------------------------------------------------
      ; Display status to the user
      ;------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Info", Program\LastWindow)
      
      ;------------------------------------------------------------------------------------------
      ; Display status to the user
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Could not open the [" + Program\LastWindow + "] window.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; Display status to the user
    ;--------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "The [" +  Program\LastWindow + "] window is still open, close that one first.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; Warn about the alarm checker still running
  ;----------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 89
; FirstLine = 48
; Folding = -
; EnableXP
; HideErrorLog