﻿;==========================================================================================================================================================
; Show a list of all the keyboard shortcuts
;==========================================================================================================================================================

Procedure KeysForPasswords()
  
  ;----------------------------------------------------------------------------------------------
  ; Check if a previous window is open
  ;----------------------------------------------------------------------------------------------
  
  If Program\WindowMutex <> 1
    
    ;--------------------------------------------------------------------------------------------
    ; Try to open the data window
    ;--------------------------------------------------------------------------------------------
    
    If Window_Keys()
      
      ;------------------------------------------------------------------------------------------
      ; Prevent user input on the main window
      ;------------------------------------------------------------------------------------------
      
      DisableWindow(#Window_PasswordMuncher, #True)
      
      ;------------------------------------------------------------------------------------------
      ; Warn other components a window is open and not to attempt to open another
      ;------------------------------------------------------------------------------------------
      
      Program\WindowMutex = 1
      
      ;------------------------------------------------------------------------------------------
      ; Add the various keyboard shortcuts
      ;------------------------------------------------------------------------------------------
      
      AddKeyboardShortcut(#Window_Keys, #PB_Shortcut_Escape, #Shortcut_Keys_Escape)
      
      ;------------------------------------------------------------------------------------------
      ; Set the common window and statusbar message
      ;------------------------------------------------------------------------------------------
      
      Message.s = "Show keyboard shortcuts"
      
      ;------------------------------------------------------------------------------------------
      ; Use the common message as a window identifier
      ;------------------------------------------------------------------------------------------
      
      Program\LastWindow = Message.s
      
      ;------------------------------------------------------------------------------------------
      ; Set the window title with the common message and next record number
      ;------------------------------------------------------------------------------------------
      
      SetWindowTitle(#Window_Keys, Message.s)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Category list controls")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryAdd)    + Chr(10) + #Text_Category_Add,     ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryCopy)   + Chr(10) + #Text_Category_Copy,    ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryDelete) + Chr(10) + #Text_Category_Delete,  ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryEdit)   + Chr(10) + #Text_Category_Edit,    ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Category editor controls")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategorySave)   + Chr(10) + #Text_Category_Save,    ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryExit)   + Chr(10) + #Text_Category_Exit,    ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_CategoryEscape) + Chr(10) + #Text_Category_Escape,  ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Main form controls")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Add)            + Chr(10) + #Text_Add,              ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Copy)           + Chr(10) + #Text_Copy,             ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Delete)         + Chr(10) + #Text_Delete,           ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Edit)           + Chr(10) + #Text_Edit,             ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Favourite)      + Chr(10) + #Text_Favourite,        ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Help)           + Chr(10) + #Text_Help,             ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Keyboard)       + Chr(10) + #Text_Keyboard,         ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Lock)           + Chr(10) + #Text_Lock,             ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Search)         + Chr(10) + #Text_Search,           ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Help)           + Chr(10) + #Text_Help,             ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Print)          + Chr(10) + #Text_Print,            ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Export)         + Chr(10) + #Text_Export,           ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Vacuum)         + Chr(10) + #Text_Vacuum,           ImageID(#Shortcuts)) 
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Exit)           + Chr(10) + #Text_Exit,             ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Data form keys")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataSave)       + Chr(10) + #Text_DataSave,         ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataImport)     + Chr(10) + #Text_DataImport,       ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataExport)     + Chr(10) + #Text_DataExport,       ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataSearch)     + Chr(10) + #Text_DataSearch,         ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataExit)       + Chr(10) + #Text_DataExit,         ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_DataEscape)     + Chr(10) + #Text_DataEscape,       ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Search window keys")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_SearchFirst)      + Chr(10) + #Text_SearchFirst,        ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_SearchEscape)     + Chr(10) + #Text_SearchEscape,       ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "Miscellaneous keys")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, "" + Chr(10) + "")
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_LockProgram)    + Chr(10) + #Text_LockProgram,      ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_EditPassword)   + Chr(10) + #Text_EditPassword,     ImageID(#Shortcuts))
      
      AddGadgetItem(#Gadget_Keys_Keylist, -1, GetShortCutText(#ShortcutKeys_Enter)          + Chr(10) + #Text_Enter,            ImageID(#Shortcuts))
      
      ;------------------------------------------------------------------------------------------
      ; Set the current operation details on the the main window status bar
      ;------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  Message.s)
      
      ;------------------------------------------------------------------------------------------
      ; Set focus on the appointment name field
      ;------------------------------------------------------------------------------------------
      
      SetActiveGadget(#Gadget_Keys_Keylist)
      
      ;------------------------------------------------------------------------------------------
      ; Display status to the user
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Could not open the [" + Program\LastWindow + "] window.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; Display status to the user
    ;--------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  "The [" +  Program\LastWindow + "] window is still open, close that one first.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; Warn about the alarm checker still running
  ;----------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 221
; FirstLine = 181
; Folding = -
; EnableXP
; HideErrorLog