;==========================================================================================================================================================
; Check that there is a new password
;==========================================================================================================================================================

Procedure CheckNewPassWord()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FocusID.i = GetActiveGadget()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select FocusId.i
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case #Gadget_NewPassword_NewPassWord
    
      Program\NewPassWord = GetGadgetText(#Gadget_NewPassword_NewPassWord)
      
      If Program\NewPassWord <> ""
        
        ; < = Less Than, > = Greater Than
        
        If Len(Program\NewPassWord) > 7 And Len(Program\NewPassWord) < 26
          
          DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #False)
          
          SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
          
        Else
          
          DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #True)
          
          MessageRequester("Security Error", "Password too short." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "It must be between 8 and 25 characters in length.",  #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_NewPassword_NewPassWord, "")
          
          SetActiveGadget(#Gadget_NewPassword_NewPassWord)
          
        EndIf
        
      ElseIf Program\NewPassWord = ""
        
        DisableGadget(#Gadget_NewPassword_ConfirmPassWord, #True)
        
        MessageRequester("Security Error",  "Password empty."      + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again or press ESCape to exit.",                 #MB_ICONWARNING)
        
        SetActiveGadget(#Gadget_NewPassword_NewPassWord)
        
      EndIf
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Gadget_NewPassword_ConfirmPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ConfirmPassWord.s = GetGadgetText(#Gadget_NewPassword_ConfirmPassWord)
      
      If ConfirmPassWord.s = ""
        
        MessageRequester("Security Error",  "Confirmation password empty." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again or press ESCape to exit.", #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_NewPassword_ConfirmPassWord, "")
        
        SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
        
      ElseIf ConfirmPassWord.s <> Program\NewPassWord
        
        MessageRequester("Security Error", "The passwords do not match." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again or press ESCape to exit.",  #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_NewPassword_ConfirmPassWord, "")
        
        SetActiveGadget(#Gadget_NewPassword_ConfirmPassWord)
        
      ElseIf ConfirmPassWord.s  = Program\NewPassWord
        
        Program\MD5FingerPrint = MD5Fingerprint(@ConfirmPassWord,  Len(ConfirmPassWord.s))
        
        QueryString.s = "UPDATE Preferences "
        
        QueryString.s + "SET MD5FingerPrint = '" + RepQuote(Program\MD5FingerPrint) + "' "
        
        QueryString.s + "WHERE Record = '1'"
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          SetInfoBarArea("Headings",  "Info",  "The new password has been added to the database.")
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "Could not add new password to database." + DatabaseError())
          
        EndIf
        
        Program\NewPassWord = ""
        
        CloseMyWindow(#Window_NewPassword)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 5
; Folding = -
; EnableXP
; HideErrorLog