;==========================================================================================================================================================
; Check that the old password and confirmation passwords match
;==========================================================================================================================================================

Procedure CheckPassWords()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FocusId.i = GetActiveGadget()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select FocusId.i
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case #Gadget_EditPassword_ConfirmPassWord
    
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ConfirmPassWord.s = GetGadgetText(#Gadget_EditPassword_ConfirmPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If ConfirmPassWord.s <> ""
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ConfirmPassWord.s = MD5Fingerprint(@ConfirmPassWord,  Len(ConfirmPassWord.s))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Program\OldPassWord <> ConfirmPassWord.s
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          MessageRequester("Security Error", "Passwords do not match." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again or press ESCape to exit.", #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_EditPassword_ConfirmPassWord, "")
          
          SetActiveGadget(#Gadget_EditPassword_ConfirmPassWord)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        ElseIf Program\OldPassWord = ConfirmPassWord.s
          
          SetActiveGadget(#Gadget_EditPassword_NewPassWord)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        MessageRequester("Security Error", "Confirmation password empty." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "Try again or press ESCape to exit.", #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_EditPassword_ConfirmPassWord, "")
        
        SetActiveGadget(#Gadget_EditPassword_ConfirmPassWord)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Gadget_EditPassword_NewPassWord
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      NewPassWord.s = GetGadgetText(#Gadget_EditPassword_NewPassWord)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If NewPassWord.s <> ""
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Len(NewPassWord.s) > 7 And Len(NewPassWord.s) < 26
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\MD5FingerPrint = MD5Fingerprint(@NewPassWord,  Len(NewPassWord.s))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE Preferences "
          
          QueryString.s + "SET MD5FingerPrint = '" + RepQuote(Program\MD5FingerPrint) + "' "
          
          QueryString.s + "WHERE Record = '1'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
          Else
            
            Debug DatabaseError()
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\OldPassword = ""
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CloseMyWindow(#Window_EditPassword)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          MessageRequester("Security Error", "This password is too short." + Chr(10) + Chr(13) + Chr(10) + Chr(13) + "It must be between 8 and 25 characters in length.",  #MB_ICONWARNING)
          
          SetGadgetText(#Gadget_EditPassword_NewPassWord, "")
          
          SetActiveGadget(#Gadget_EditPassword_NewPassWord)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        MessageRequester("Security Error",  "The password field is empty, nothing was saved.",  #MB_ICONWARNING)
        
        SetGadgetText(#Gadget_EditPassword_NewPassWord, "")
        
        SetActiveGadget(#Gadget_EditPassword_NewPassWord)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 183
; FirstLine = 146
; Folding = -
; EnableXP