﻿;==========================================================================================================================================================
; Boiled lobsters
;==========================================================================================================================================================

Declare MainWindowCallback(hWnd, uMsg, wParam, lParam)                                               ; 
Declare DataWindowCallback(hWnd, uMsg, wParam, lParam)                                               ; 

;==========================================================================================================================================================
; Main program bits
;==========================================================================================================================================================

XIncludeFile "PasswordMuncher_Compiler.pb"                                                          ; Compiler check constants for RichEdit handling
XIncludeFile "PasswordMuncher_Constants.pb"                                                         ; Visual designer created constants
XIncludeFile "PasswordMuncher_Windows.pb"                                                           ; Visual designer created windows
XIncludeFile "PasswordMuncher_MyDeclarations.pb"                                                    ; My procedural declarations
XIncludeFile "PasswordMuncher_MyConstants.pb"                                                       ; My personal constants

;==========================================================================================================================================================
; NetMaestro's mouse hover events code
;==========================================================================================================================================================

XIncludeFile "Modules\ThirdParty\_NM_Hover.pbi"                                                     ; NetMaestro's Hover library
XIncludeFile "Modules\ThirdParty\_MenuColourPicker.pbi"                                             ; Show a POP-up menu which contains a selection of 'standard colour' cells. Srod, popup menu colour picker
XIncludeFile "Modules\ThirdParty\_OwnerdrawComboIconsFonts.pbi"                                     ; FluidByte code to retrieve the currently installed windows fonts

;==========================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==========================================================================================================================================================

XIncludeFile "Modules\RtfTools\_CatchRTF.pbi"                                                       ; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
XIncludeFile "Modules\RtfTools\_CatchRTF_Callback.pbi"                                              ; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget
XIncludeFile "Modules\RtfTools\_GetRTF.pbi"                                                         ; Stream the RTF data from the requested gadget
XIncludeFile "Modules\RtfTools\_GetRTFCallback.pbi"                                                 ; Callback for the RTF stream requester
XIncludeFile "Modules\RtfTools\_GetRTFLen.pbi"                                                      ; Get the length of RTF data in the requested gadget
XIncludeFile "Modules\RtfTools\_GetRTFLenCallback.pbi"                                              ; Callback for the RTF length retriever
XIncludeFile "Modules\RtfTools\_GetRtfData.pbi"                                                     ; Get RTF data from the requested gadget

;==========================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==========================================================================================================================================================

XIncludeFile "Modules\RTF Handling\_Editor_Bulleted.pbi"                                            ; Set bulleted text mode
XIncludeFile "Modules\RTF Handling\_Editor_Color.pbi"                                               ; Set font colour
XIncludeFile "Modules\RTF Handling\_Editor_FindTextn.pbi"                                           ; Find whole text strings with no splitting
XIncludeFile "Modules\RTF Handling\_Editor_Font.pbi"                                                ; Set font type
XIncludeFile "Modules\RTF Handling\_Editor_FontSize.pbi"                                            ; Set font size
XIncludeFile "Modules\RTF Handling\_Editor_Format.pbi"                                              ; Set font style (Bold, italic etc)
XIncludeFile "Modules\RTF Handling\_Editor_JustifyParagraph.pbi"                                    ; Set left, center, right justify
XIncludeFile "Modules\RTF Handling\_Editor_Load.pbi"                                                ; Load an RTF file
XIncludeFile "Modules\RTF Handling\_Editor_Save.pbi"                                                ; Save an RTF file
XIncludeFile "Modules\RTF Handling\_Editor_StreamCallback.pbi"                                      ; RTF load and save stream callback
XIncludeFile "Modules\RTF Handling\_Editor_Wrap.pbi"                                                ; Turn editor word wrap on

;==========================================================================================================================================================
; Me, wrapper routines
;==========================================================================================================================================================

XIncludeFile "Modules\RTF Wrappers\_Editor_Look_Text.pbi"          ; ** NOT USED YET**              ; Search for text in the document
XIncludeFile "Modules\RTF Wrappers\_Editor_Save_RTF_File.pbi"                                       ; Wrapper for "Save an RTF file"
XIncludeFile "Modules\RTF Wrappers\_Editor_Load_RTF_File.pbi"                                       ; Wrapper for "Load an RTF file"
XIncludeFile "Modules\RTF Wrappers\_Editor_SetColour.pbi"                                           ; Wrapper for "Set font colour" and "MenuColourPicker"
XIncludeFile "Modules\RTF Wrappers\_Editor_SetFont.pbi"                                             ; Wrapper for Editor_Font
XIncludeFile "Modules\RTF Wrappers\_FontResize.pbi"                                                 ; Resize font with Control + Up and Down keys

;==========================================================================================================================================================
; Generic modules used by all programs
;==========================================================================================================================================================

XIncludeFile "Modules\Generic\_ChangeIcon.pbi"                                                      ; Update each collumn of a ListIconGadget with a user defined icon as needed
XIncludeFile "Modules\Generic\_FormatField.pbi"                                                     ; Format the passed string to the correct field length for printing/copying to clipboard etc
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                 ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_KillQuote.pbi"                                                       ; Kill double quotes in strings for display purposes
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                        ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_RepQuote.pbi"                                                        ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                   ; Remove borders from various gadgets
XIncludeFile "Modules\Generic\_StringFirstUpper.pbi"                                                ; Convert the first character of a string to uppercase
XIncludeFile "Modules\Generic\_TextToXML.pbi"                                                       ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
XIncludeFile "Modules\Generic\_XMLToText.pbi"                                                       ; Strip illegal characters from text strings

;==========================================================================================================================================================
; Database functions
;==========================================================================================================================================================

XIncludeFile "Modules\Database\_CountRecords.pbi"                                                   ; Count the number of records in an SQLite database
XIncludeFile "Modules\Database\_DatabaseLastInsertRowId.pbi"                                        ; Get the ID of the last inserted record
XIncludeFile "Modules\Database\_LastRecord.pbi"                                                     ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
XIncludeFile "Modules\Database\_OpenSystemDatabase.pbi"                                             ; Try to open the system database and create missing tables

;==========================================================================================================================================================
; Custom include files
;==========================================================================================================================================================

XIncludeFile "Modules\Custom\_BuildImageList.pbi"                                                   ; Rebuild the image list as it gets trashed by the clear command
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                                    ; Fade the window out gently, close it and reset the mutex
XIncludeFile "Modules\Custom\_MakeSureDirectoryPathExists.pbi"                                      ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Custom\_SetInfoBarArea.pbi"                                                   ; Send messages and error reports to the fake status bar area
XIncludeFile "Modules\Custom\_SetHoverIcons.PBI"                                                    ; Set the correct icons to the selected hoverable gadget
XIncludeFile "Modules\Custom\_SortTitleStrings.pbi"                                                 ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
XIncludeFile "Modules\Custom\_StatusBarButtonTip.pbi"                                               ; Show button tip in the statusbar area
XIncludeFile "Modules\Custom\_TitleBarClock.pbi"                                                    ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_MainWindowCallback.pbi"                                               ; Window snap, strikeoutfont and more
XIncludeFile "Modules\Custom\_DataWindowCallback.pbi"                                               ; Window snap, strikeoutfont and more

;==========================================================================================================================================================
; Categories management
;==========================================================================================================================================================

XIncludeFile "Modules\Category\_AddCategory.pbi"                                                    ; Add a new category to the database
XIncludeFile "Modules\Category\_CopyCategory.pbi"                                                   ; Copy the current category to the clipboard
XIncludeFile "Modules\Category\_DeleteCategory.pbi"                                                 ; Delete the selected category
XIncludeFile "Modules\Category\_EditCategory.pbi"                                                   ; Edit the selected category
XIncludeFile "Modules\Category\_LoadCategories.pbi"                                                 ; Load all the categories into the category bar
XIncludeFile "Modules\Category\_SaveCategory.pbi"                                                   ; Save the changed category data to the database
XIncludeFile "Modules\Category\_ShowCategory.pbi"                                                   ; Show the items that belong to a particular category
XIncludeFile "Modules\Category\_SortCategoryEntries.pbi"                                            ; Sort the category list after an add or edit

;==========================================================================================================================================================
; All data handling
;==========================================================================================================================================================

XIncludeFile "Modules\Data\_AddNewData.pbi"                                                         ; Add a new PasswordMuncher item
XIncludeFile "Modules\Data\_CopyDataToClipboard.pbi"                                                ; Copy highlighted data to the system clipboard
XIncludeFile "Modules\Data\_DeleteCurrentData.pbi"                                                  ; Mark the selected item as deleted
XIncludeFile "Modules\Data\_DisplayTitleString.pbi"                                                 ; Display PasswordMuncher title in the list
XIncludeFile "Modules\Data\_EditOldData.pbi"                                                        ; Edit the old PasswordMuncherd ata
XIncludeFile "Modules\Data\_LockCurrentData.pbi"                                                    ; Lock the current record against deletion and editing
XIncludeFile "Modules\Data\_MarkAsFavourite.pbi"                                                    ; Mark this entry as a favourite item
XIncludeFile "Modules\Data\_OpenSearchWindow.pbi"                                                   ; Open the text search window
XIncludeFile "Modules\Data\_SavePasswordData.pbi"                                                   ; Save the new or edited PasswordMuncher data
XIncludeFile "Modules\Data\_SearchPasswords.pbi"                                                    ; Show all the items in the database
XIncludeFile "Modules\Data\_ShowPasswordData.pbi"                                                   ; Show the data string for PasswordMuncher on the screen
XIncludeFile "Modules\Data\_VacuumDeletedData.pbi"                                                  ; Clean all deleted items from the database immediately

;==========================================================================================================================================================
; Export and import routines
;==========================================================================================================================================================

XIncludeFile "Modules\Export\_ExportDataItems.pbi"                                                  ; Export data data to a standard XML file

;==========================================================================================================================================================
; Create a new password if there wasn't one previously
;==========================================================================================================================================================

XIncludeFile "Modules\Security\_NewPassWordWindow.pbi"                                              ; Open the new password window
XIncludeFile "Modules\Security\_CheckNewPassWord.pbi"                                               ; Check that there is a new password
XIncludeFile "Modules\Security\_CheckConfirmPassWord.pbi"                                           ; Check that the old password and confirmation passwords match

;==========================================================================================================================================================
; Security password check on program startup
;==========================================================================================================================================================

XIncludeFile "Modules\Security\_StartPassWordWindow.pbi"                                            ; Show a password lock screen at program start
XIncludeFile "Modules\Security\_CheckStartUpPassWord.pbi"                                           ; Check the startup unlocking password

;==========================================================================================================================================================
; Edit an existing password
;==========================================================================================================================================================

XIncludeFile "Modules\Security\_EditpassWordWindow.pbi"                                             ; Open the edit password window
XIncludeFile "Modules\Security\_CheckpassWords.pbi"                                                 ; Check that the old password and confirmation passwords match

;==========================================================================================================================================================
; Lock and unlock the program window
;==========================================================================================================================================================

XIncludeFile "Modules\Security\_LockProgramWindow.pbi"                                              ; Lock the program window now
XIncludeFile "Modules\Security\_CheckUnlockPassWord.pbi"                                            ; Check the unlocking password
XIncludeFile "Modules\Security\_UnLockProgramWindow.pbi"                                            ; UnLock the program window now

;==========================================================================================================================================================
; Minimising and maximising the program window
;==========================================================================================================================================================

XIncludeFile "Modules\Security\_HideProgramWindow.pbi"                                              ; Hide the program window
XIncludeFile "Modules\Security\_ShowProgramWindow.pbi"                                              ; Show the program window

;==========================================================================================================================================================
; Various help and informational files
;==========================================================================================================================================================

;XIncludeFile "Modules\Help\_AboutProgram.pbi"                                                       ; A quick 'about me' blurb
XIncludeFile "Modules\Help\_HelpForPasswords.pbi"                                                   ; Show an RTF help file loaded into this window
XIncludeFile "Modules\Help\_KeysForPasswords.pbi"                                                   ; Show a list of all the keyboard shortcuts

;==========================================================================================================================================================
; Open the master database from which we also pull the setup data.
;==========================================================================================================================================================

OpenSystemDatabase()                                                                                  ; Open the system database
  
;==========================================================================================================================================================
; 
;==========================================================================================================================================================

If Window_PasswordMuncher()
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  SetWindowCallback(@MainWindowCallback(), #Window_PasswordMuncher)
  
  ;----------------------------------------------------------------------------------------------
  ; Get the password from the database if any exists
  ;----------------------------------------------------------------------------------------------
  QueryString.s = "SELECT MD5FingerPrint FROM Preferences "
  QueryString.s + "WHERE Record = '1'"
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> 0
    While NextDatabaseRow(Program\DatabaseHandle)
      Program\MD5FingerPrint = KillQuote(GetDatabaseString(Program\DatabaseHandle, 0))
    Wend
    FinishDatabaseQuery(Program\DatabaseHandle)
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; If no password, get a new one or open the password window if one exists
  ;----------------------------------------------------------------------------------------------
  If Program\MD5FingerPrint = ""
    NewPassWordWindow()
  ElseIf  Program\MD5FingerPrint <> ""
    StartPassWordWindow()
  EndIf

  ;----------------------------------------------------------------------------------------------
  ; Create the permanent title bar clock timer
  ;----------------------------------------------------------------------------------------------
  SetTimer_(WindowID(#Window_PasswordMuncher), #TitleBarClockTimer, 1000, @TitleBarClock())    ; 1000 = 1 second

  ;------------------------------------------------------------------------------------------------
  ; Set the initial program quit flag
  ;------------------------------------------------------------------------------------------------
  Program\QuitValue = 0
  
  ;------------------------------------------------------------------------------------------------
  ; Set a marker for first time only operations
  ;------------------------------------------------------------------------------------------------
  Program\FirstTime = 0
  
  ;------------------------------------------------------------------------------------------------
  ; Add the chosen icons to the main listicongadget to be used by the changeicon procedure
  ;------------------------------------------------------------------------------------------------
  BuildImageList(#Gadget_PasswordMuncher_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; Remove borders from the details pane by remove windows theming support, gets rid of 1 pixel border
  ;------------------------------------------------------------------------------------------------
  SetWindowTheme_(GadgetID(#Gadget_PasswordMuncher_Details), @null.w, @null.w)
  
  ;================================================================================================
  ; Remove borders from list type gadgets
  ;================================================================================================
  RemoveBorders(#Gadget_PasswordMuncher_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; Turn on mouse event hover testing, this is NetMaestro's code.
  ;------------------------------------------------------------------------------------------------
  InitHoverEvents(#Window_PasswordMuncher)

  ;------------------------------------------------------------------------------------------------
  ; Add the hovering effect to the category buttons
  ;------------------------------------------------------------------------------------------------
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_AddCategory))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_CopyCategory))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_DeleteCategory))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_EditCategory))
  
  ;------------------------------------------------------------------------------------------------
  ; Add the flat imagegadget only buttons to the list of mouse hover-able gadgets
  ;------------------------------------------------------------------------------------------------
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Add))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Copy))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Delete))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Edit))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Favourite))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Lock))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Search))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Help))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Print))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Export))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Vacuum))
  AddHoverGadget(GadgetID(#Gadget_PasswordMuncher_Exit))

  ;------------------------------------------------------------------------------------------------
  ; Load a strikeout font to be used on the item list when an appointment is marked as deleted
  ;------------------------------------------------------------------------------------------------
  CurrentFont.i   = GetGadgetFont(#Gadget_PasswordMuncher_Titles)                                      ; Get current font
  GetObject_(CurrentFont.i, SizeOf(LOGFONT), @logf.LOGFONT)
  mFontName.s      = PeekS(@logf\lfFacename[0])
  hDEviceContext  = CreateDC_(@"DISPLAY", 0, 0, 0)
  LogPixSY        = GetDeviceCaps_(hDEviceContext, #LOGPIXELSY)
  DeleteDC_(hDEviceContext)
  mFontsize.F      = - (logf\lfHeight * 72) / LogPixSY
  LoadFont(#FontStrikeoutYes, mFontName.s, mFontsize.F, #PB_Font_StrikeOut | #PB_Font_Italic | #PB_Font_HighQuality)  ; Load current font And add strikeout attribute
  LoadFont(#FontStrikeoutNo,  mFontName.s, mFontsize.F, #PB_Font_HighQuality)
  
  ;------------------------------------------------------------------------------------------------
  ; Limit the number of search box characters and set the cue banner text. These variables are set
  ; in the AppointmentMuncher_Myconstants file.
  ;------------------------------------------------------------------------------------------------
  SendMessage_(GadgetID(#Gadget_PasswordMuncher_Searchstring), #EM_SETLIMITTEXT, 67, 0)
  SendMessage_(GadgetID(#Gadget_PasswordMuncher_Searchstring), #EM_SETCUEBANNER,  1,  Program\SearchCueText)
  
  ;------------------------------------------------------------------------------------------------
  ; Add category keyboard shortcuts
  ;------------------------------------------------------------------------------------------------
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_1, #Shortcut_Category_Add)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_2, #Shortcut_Category_Copy)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_3, #Shortcut_Category_Delete)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_4, #Shortcut_Category_Edit)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the button keyboard shortcuts
  ;------------------------------------------------------------------------------------------------
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_A, #Shortcut_PasswordMuncher_Add)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_C, #Shortcut_PasswordMuncher_Copy)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_D, #Shortcut_PasswordMuncher_Delete)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_E, #Shortcut_PasswordMuncher_Edit)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_F, #Shortcut_PasswordMuncher_Favourite)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_H, #Shortcut_PasswordMuncher_Help)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_K, #Shortcut_PasswordMuncher_Keyboard)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_L, #Shortcut_PasswordMuncher_Lock)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_S, #Shortcut_PasswordMuncher_Search)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_P, #Shortcut_PasswordMuncher_Print)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_X, #Shortcut_PasswordMuncher_Export)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_V, #Shortcut_PasswordMuncher_Vacuum) 
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Alt     | #PB_Shortcut_Q, #Shortcut_PasswordMuncher_Exit)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the extra hidden options keyboard shortcuts
  ;------------------------------------------------------------------------------------------------
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Control | #PB_Shortcut_L, #Shortcut_PasswordMuncher_LockProgram)
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Control | #PB_Shortcut_E, #Shortcut_PasswordMuncher_EditPassword)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the reurn button shortcut that starts searching
  ;------------------------------------------------------------------------------------------------
  AddKeyboardShortcut(#Window_PasswordMuncher, #PB_Shortcut_Return,                   #Shortcut_PasswordMuncher_Enter)
  
  ;------------------------------------------------------------------------------------------------
  ; Create a popup image menu for options that don't have buttons
  ;------------------------------------------------------------------------------------------------
  If CreatePopupImageMenu(#Menu_PasswordMuncher, #PB_Menu_ModernLook) <> 0
    MenuItem(#Menu_LockProgram,  #Text_LockProgram,   ImageID(#LockProgram))
    MenuItem(#Menu_EditPassword, #Text_EditPassword,  ImageID(#EditPassword))
  Else
    If MessageRequester("Popup menu error", "Could not setup popup menu, continuing.")
    Else
    EndIf
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Add the SQL search type operators to the search combo box
  ;------------------------------------------------------------------------------------------------
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "All fields",   ImageID(#ComboAll))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Title",        ImageID(#ComboSql))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Information",  ImageID(#ComboSql))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Favourite",    ImageID(#ComboSql))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Protected",    ImageID(#ComboSql))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Deleted",      ImageID(#ComboSql))
  AddGadgetItem(#Gadget_PasswordMuncher_Searchfield, -1, "Record",       ImageID(#ComboSql))
  
  SetGadgetState(#Gadget_PasswordMuncher_Searchfield, 0)
  
  ;------------------------------------------------------------------------------------------------
  ; Set the fake statusbar heading appropriate for the run time of the program
  ;------------------------------------------------------------------------------------------------
  NumberOfItems.s = CountRecords("Record", "Passwords")
  
  If NumberOfItems.s = "0"
    SetInfoBarArea("Headings",  "Welcome",  "Program " + #Program + " is ready to go.")
    SetInfoBarArea("Number",    "",         "?")
    SetInfoBarArea("Records",   "",         "0")
  ElseIf NumberOfItems.s <> "0"
    SetGadgetState(#Gadget_PasswordMuncher_Titles, 0)
    PostEvent(#PB_Event_Gadget, #Window_PasswordMuncher, #Gadget_PasswordMuncher_Titles, #PB_EventType_Change)
    SetInfoBarArea("Headings",  "Welcome",  "Welcome to PasswordMuncher " + #Program)
    SetInfoBarArea("Records",   "",         NumberOfItems.s)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Now display all the categories available
  ;------------------------------------------------------------------------------------------------
  LoadCategories()

  ;------------------------------------------------------------------------------------------------
  ; Set initial search cue font
  ;------------------------------------------------------------------------------------------------
  SetGadgetFont(#Gadget_PasswordMuncher_Searchstring, FontID(Program\SearchCueFont))

  ;------------------------------------------------------------------------------------------------
  ; Set focus on the search bar
  ;------------------------------------------------------------------------------------------------
  SetActiveGadget(#Gadget_PasswordMuncher_Searchstring)

  ;================================================================================================
  ; Main event processing area
  ;================================================================================================
  Repeat
    EventID  =  WaitWindowEvent()
    MenuID   =  EventMenu()
    GadgetID =  EventGadget()
    WindowID =  EventWindow()
    ;--------------------------------------------
    ; 
    ;--------------------------------------------
    Select EventID
      Case #PB_Event_CloseWindow
        Select WindowID
          ;--------------------------------------------
          ; Security windows
          ;--------------------------------------------
          Case #Window_StartUpPassword                : Program\QuitValue = 1
          Case #Window_EditPassword                   : CloseMyWindow(#Window_EditPassword)
          Case #Window_UnlockPassword                 : Program\QuitValue = 1
          Case #Window_NewPassword                    : Program\QuitValue = 1
          ;--------------------------------------------
          ; Normal windows
          ;--------------------------------------------
          Case #Window_PasswordMuncher                : Program\QuitValue = 1
          Case #Window_Data                           : CloseMyWindow(#Window_Data)
          Case #Window_Category                       : CloseMyWindow(#Window_Category)
          Case #Window_Help                           : CloseMyWindow(#Window_Help)
          Case #Window_Keys                           : CloseMyWindow(#Window_Keys)
          Case #Window_Search                         : CloseWindow(#Window_Search)
        EndSelect
        ;------------------------------------------------------------------------------------------
        ; Minimise the program to the windows tray and set icon and tooltip
        ;------------------------------------------------------------------------------------------
      Case #PB_Event_MinimizeWindow
        Select EventWindow()
          Case #Window_PasswordMuncher                : HideProgramWindow()
        EndSelect
        ;----------------------------------------------
        ; 
        ;----------------------------------------------
      Case #PB_Event_Menu
        Select MenuID
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Menu_LockProgram                      : LockProgramWindow()
          Case #Menu_EditPassword                     : EditPassWordWindow()
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #ShortCut_NewPassword_Return           : CheckNewPassword()
          Case #ShortCut_NewPassword_Escape           : Program\QuitValue = 1
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #ShortCut_StartUpPassword_Return       : CheckStartUpPassword()
          Case #ShortCut_StartUpPassword_Escape       : Program\QuitValue = 1
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #ShortCut_EditPassword_Return          : CheckPassWords()
          Case #ShortCut_EditPassword_Escape          : CloseMyWindow(#Window_EditPassword)
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #ShortCut_UnlockPassword_Return        : CheckUnlockPassWord()
          Case #ShortCut_UnlockPassword_Escape        : Program\QuitValue = 1
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #ShortCut_Help_Escape                  : CloseMyWindow(#Window_Help)
          Case #ShortCut_Keys_Escape                  : CloseMyWindow(#Window_Keys)
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Shortcut_Category_Add                 : AddCategory()
          Case #Shortcut_Category_Copy                : CopyCategory()
          Case #Shortcut_Category_Delete              : DeleteCategory()
          Case #Shortcut_Category_Edit                : EditCategory()
          Case #Shortcut_Category_Escape              : CloseMyWindow(#Window_Category)
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Shortcut_PasswordMuncher_Add          : AddNewData()
          Case #Shortcut_PasswordMuncher_Copy         : CopyDataToClipboard()
          Case #Shortcut_PasswordMuncher_Delete       : DeleteCurrentData()
          Case #Shortcut_PasswordMuncher_Edit         : EditOldData()
          Case #Shortcut_PasswordMuncher_Favourite    : MarkAsFavourite()
          Case #Shortcut_PasswordMuncher_Help         : HelpForPasswords()
          Case #Shortcut_PasswordMuncher_Keyboard     : KeysForPasswords()
          Case #Shortcut_PasswordMuncher_Lock         : LockCurrentData()
          Case #Shortcut_PasswordMuncher_Search       : SearchPasswords()
          Case #Shortcut_PasswordMuncher_Help         : HelpForPasswords()
          Case #Shortcut_PasswordMuncher_Print        : ; PrintDataItem()
          Case #Shortcut_PasswordMuncher_Export       : ExportDataItems()
          Case #Shortcut_PasswordMuncher_Vacuum       : VacuumDeletedData()
          Case #Shortcut_PasswordMuncher_Exit         : Program\QuitValue = 1
          Case #Shortcut_PasswordMuncher_Enter        : SearchPasswords()
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Shortcut_PasswordMuncher_EditPassword : EditPassWordWindow()
          Case #Shortcut_PasswordMuncher_LockProgram  : LockProgramWindow()
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Shortcut_Data_Bold                    : Editor_Format(#Gadget_Data_Details, #CFE_BOLD,        1)
          Case #Shortcut_Data_Italic                  : Editor_Format(#Gadget_Data_Details, #CFE_ITALIC,      1)
          Case #Shortcut_Data_Underline               : Editor_Format(#Gadget_Data_Details, #CFE_UNDERLINE,   1)
          Case #Shortcut_Data_Strikeout               : Editor_Format(#Gadget_Data_Details, #CFE_STRIKEOUT,   1)
          Case #Shortcut_Data_Superscript             : Editor_Format(#Gadget_Data_Details, #CFE_SUPERSCRIPT, 1)
          Case #Shortcut_Data_Subscript               : Editor_Format(#Gadget_Data_Details, #CFE_SUBSCRIPT,   1)
          Case #Shortcut_Data_Link                    : Editor_Format(#Gadget_Data_Details, #CFE_LINK,        1)
          Case #Shortcut_Data_FontUp                  : FontResize(#Gadget_Data_Details, "Up")
          Case #Shortcut_Data_FontDown                : FontResize(#Gadget_Data_Details, "Down")
          Case #Shortcut_Data_Save                    : SavePasswordData()
          Case #Shortcut_Data_Import                  : Editor_Load_RTF_File(#Gadget_Data_Details)
          Case #Shortcut_Data_Export                  : Editor_Save_RTF_File(#Gadget_Data_Details)
          Case #Shortcut_Data_Search                  : OpenSearchWindow()
          Case #Shortcut_Data_Exit                    : CloseMyWindow(#Window_Data)
          Case #Shortcut_Data_Escape                  : CloseMyWindow(#Window_Data)
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Shortcut_Search_SearchFirst           : Editor_Look_Text(#Gadget_Data_Details)
          Case #Shortcut_Search_Escape                : CloseWindow(#Window_Search)
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
        EndSelect
        ;----------------------------------------------
        ; 
        ;----------------------------------------------
      Case #PB_Event_Gadget
        Select GadgetID
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
;           Case #Gadget_NewPassword_NewPassWord
;             Select EventType()
;               Case #PB_EventType_LostFocus            : CheckNewPassword()
;             EndSelect
;           Case #Gadget_NewPassword_ConfirmPassWord
;             Select EventType()
;               Case #PB_EventType_LostFocus            : CheckConfirmPassWord()
;             EndSelect
          ;--------------------------------------------
          ; 
          ;--------------------------------------------
          Case #Gadget_PasswordMuncher_Category
            Select EventType()
              Case #PB_EventType_LeftClick            : ShowCategory()
              Case #PB_EventType_LeftDoubleClick      : EditCategory()
              Case #PB_EventType_RightDoubleClick     : AddCategory()
              Case #PB_EventType_Change               : ShowCategory()
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_Category_Category              : StringFirstUpper(#Gadget_Category_Category)
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_PasswordMuncher_AddCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_AddCategory_H)     : StatusBarButtonTip("AddCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_AddCategory_P)     : AddCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_AddCategory)   
            EndSelect
          Case #Gadget_PasswordMuncher_CopyCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_CopyCategory_H)    : StatusBarButtonTip("CopyCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_CopyCategory_P)    : CopyCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_CopyCategory)   
            EndSelect
          Case #Gadget_PasswordMuncher_DeleteCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_DeleteCategory_H)  : StatusBarButtonTip("DeleteCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_DeleteCategory_P)  : DeleteCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_DeleteCategory)   
            EndSelect
          Case #Gadget_PasswordMuncher_EditCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_EditCategory_H)    : StatusBarButtonTip("EditCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_EditCategory_P)    : EditCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_EditCategory)   
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_Category_Save
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_Save_H)   : StatusBarButtonTip("SaveCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_Save_P)   : SaveCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_Save)   
            EndSelect
          Case #Gadget_Category_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_Exit_H)   : StatusBarButtonTip("ExitCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_Exit_P)   : CloseMyWindow(#Window_Category)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_Exit)   
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_PasswordMuncher_Titles
            Select EventType()
              Case #PB_EventType_LeftClick            : ShowPasswordData()
              Case #PB_EventType_LeftDoubleClick      : EditOldData()
;             Case #PB_EventType_RightDoubleClick     : AddNewData()
              Case #PB_EventType_RightClick           : DisplayPopupMenu(#Menu_PasswordMuncher, WindowID(#Window_PasswordMuncher))
              Case #PB_EventType_Change               : ShowPasswordData()
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_PasswordMuncher_Add
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Add_H)        : StatusBarButtonTip("Add")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Add_P)        : AddNewData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Add)   
            EndSelect
          Case #Gadget_PasswordMuncher_Copy
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Copy_H)       : StatusBarButtonTip("Copy")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Copy_P)       : CopyDataToClipboard()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Copy)   
            EndSelect
          Case #Gadget_PasswordMuncher_Delete
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Delete_H)     : StatusBarButtonTip("Delete")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Delete_P)     : DeleteCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Delete)   
            EndSelect
          Case #Gadget_PasswordMuncher_Edit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Edit_H)       : StatusBarButtonTip("Edit")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Edit_P)       : EditOldData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Edit)   
            EndSelect
          Case #Gadget_PasswordMuncher_Favourite
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Favourite_H)  : StatusBarButtonTip("Favourite")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Favourite_P)  : MarkAsFavourite()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Favourite)   
            EndSelect
          Case #Gadget_PasswordMuncher_Lock
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Lock_H)       : StatusBarButtonTip("Lock")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Lock_P)       : LockCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Lock)        
            EndSelect
          Case #Gadget_PasswordMuncher_Search
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_H)     : StatusBarButtonTip("Search")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_P)     : SearchPasswords()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search)   
            EndSelect
          Case #Gadget_PasswordMuncher_Help
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_H)       : StatusBarButtonTip("Help")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_P)       : HelpForPasswords()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help)   
            EndSelect
          Case #Gadget_PasswordMuncher_Print
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_H)      : StatusBarButtonTip("Print")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_P)      : ; PrintDataItem()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print)   
            EndSelect
          Case #Gadget_PasswordMuncher_Export
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Export_H)     : StatusBarButtonTip("Export")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Export_P)     : ExportDataItems()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Export)   
            EndSelect
          Case #Gadget_PasswordMuncher_Vacuum
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Vacuum_H)     : StatusBarButtonTip("Vacuum")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Vacuum_P)     : VacuumDeletedData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Vacuum)      
            EndSelect
          Case #Gadget_PasswordMuncher_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Exit_H)       : StatusBarButtonTip("Exit")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Exit_P)       : Program\QuitValue = 1
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Exit)   
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_PasswordMuncher_Searchstring
            If GetGadgetText(#Gadget_PasswordMuncher_Searchstring) = ""
              SetGadgetFont(#Gadget_PasswordMuncher_Searchstring, FontID(Program\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_PasswordMuncher_Searchstring, FontID(Program\SearchNormalFont))
            EndIf
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_Data_Title                     : StringFirstUpper(#Gadget_Data_Title)
            ;------------------------------------------
            ; 
            ;------------------------------------------
          Case #Gadget_Data_font
            Select EventType()
              Case #PB_EventType_Change               : Editor_SetFont(#Gadget_Data_Details) ; Wrapper for Editor_Font
            EndSelect
            ;------------------------------------------
          Case #Gadget_Data_size
            Select EventType()
              Case #PB_EventType_Change               : Editor_FontSize(#Gadget_Data_Details, Val(GetGadgetText(#Gadget_Data_size)))
            EndSelect
            ;------------------------------------------
          Case #Gadget_Data_Character                 : ; SetSelectedCharacterLocale()
          Case #Gadget_Data_Bold                      : Editor_Format(#Gadget_Data_Details, #CFE_BOLD,        1)
          Case #Gadget_Data_Italic                    : Editor_Format(#Gadget_Data_Details, #CFE_ITALIC,      1)
          Case #Gadget_Data_Underline                 : Editor_Format(#Gadget_Data_Details, #CFE_UNDERLINE,   1)
          Case #Gadget_Data_Colour                    : Editor_SetColour(#Gadget_Data_Details)
          Case #Gadget_Data_Left                      : Editor_JustifyParagraph(#Gadget_Data_Details, #PFA_LEFT)
          Case #Gadget_Data_Middle                    : Editor_JustifyParagraph(#Gadget_Data_Details, #PFA_CENTER)
          Case #Gadget_Data_Right                     : Editor_JustifyParagraph(#Gadget_Data_Details, #PFA_RIGHT)
          Case #Gadget_Data_Bullet                    : Editor_Bulleted(#Gadget_Data_Details)
          ;--------------------------------------------
          Case #Gadget_Search_Fup                     : FontResize(#Gadget_Data_Details, "Up")
          Case #Gadget_Search_Fdown                   : FontResize(#Gadget_Data_Details, "Down")
          Case #Gadget_Search_SearchNext              : Editor_Look_Text(#Gadget_Data_Details)
          Case #Gadget_Search_Cancel                  : CloseMyWindow(#Window_Search)
          ;--------------------------------------------
          Case #Gadget_Data_Details
            Select EventType()
              Case #PB_EventType_RightClick           : ; DisplayPopupMenu(#PopMenuBar_Data, GadgetID(#Gadget_Data_Details))
              Case #PB_EventType_Change               : ; GetEditorDetails() ; Display lines, words, chars
            EndSelect
          ;--------------------------------------------
          Case #Gadget_Data_Save
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_Save_H)                  : StatusBarButtonTip("SaveData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_Save_P)                  : SavePasswordData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_Save)   
            EndSelect
          Case #Gadget_Data_Export
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_Export_H)                : StatusBarButtonTip("ExportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_Export_P)                : Editor_Save_RTF_File(#Gadget_Data_Details)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_Export)   
            EndSelect
          Case #Gadget_Data_Import
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_Import_H)                : StatusBarButtonTip("ImportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_Import_P)                : Editor_Load_RTF_File(#Gadget_Data_Details)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_Import)   
            EndSelect
          Case #Gadget_Data_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_Exit_H)                  : StatusBarButtonTip("ExitData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_Exit_P)                  : CloseMyWindow(#Window_Data)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_Exit)   
            EndSelect
            ;------------------------------------------
            ; 
            ;------------------------------------------
        EndSelect
        ;------------------------------------------------------------------------------------------
        ; Unhide the program window when the user clicks the icon in the tray
        ;------------------------------------------------------------------------------------------
      Case #PB_Event_SysTray                          : ShowProgramWindow()
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    EndSelect
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  Until Program\QuitValue
  ;------------------------------------------------------------------------------------------------
  ; FluidByte. Destroy the imagelist created for the owner drawn combo box
  ;------------------------------------------------------------------------------------------------
  ImageList_Destroy_(himlFontType)
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  CloseWindow(#Window_PasswordMuncher)
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
EndIf
;--------------------------------------------------------------------------------------------------
; 
;--------------------------------------------------------------------------------------------------
End

; For combobox in data form ,#CBS_OWNERDRAWFIXED | #CBS_HASSTRINGS)
; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 726
; FirstLine = 698
; EnableUnicode
; EnableXP
; EnableOnError
; UseIcon = Images\Shortcuts.ico
; CompileSourceDirectory
; EnablePurifier