﻿;==========================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==========================================================================================================================================================

Declare.i CatchRTF(Gadget.i, MemoryAddress.i)                                                       ; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
Declare   CatchRTF_Callback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                  ; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget
Declare   GetRTF(Gadget.i, Address.i)                                                               ; Stream the RTF data from the requested gadget
Declare.i GetRTFCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                     ; Callback for the RTF stream requester
Declare.i GetRTFLen(Gadget.i)                                                                       ; Get the length of RTF data in the requested gadget
Declare.i GetRTFLenCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                  ; Callback for the RTF length retriever
Declare.s GetRtfData(Gadget.i)                                                                      ; Get RTF data from the requested gadget

;==========================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==========================================================================================================================================================

Declare   Editor_Bulleted(Gadget.i)                                                                 ; 
Declare   Editor_Color(Gadget.i, Color.i)                                                           ; 
Declare   Editor_FindTextn(Gadget.i, TextToFind.s, ResetFlag.i)                                     ; 
Declare   Editor_Font(Gadget.i, FontName.s)                                                         ; 
Declare   Editor_FontSize(Gadget.i, Fontsize.i)                                                     ; 
Declare   Editor_Format(Gadget.i, Flags, alternate = 0)                                             ; 
Declare   Editor_JustifyParagraph(Gadget.i, justify)                                                ; 
Declare   Editor_Load(Gadget.i, FileName.s)                                                         ; 
Declare   Editor_Save(Gadget.i, FileName.s)                                                         ; 
Declare   Editor_StreamCallback(dwCookie.i, *pbBuff, cb, *pcb.LONG)                                 ; 
Declare   Editor_Wrap(Gadget.i, Flag.i)                                                             ; 

;==========================================================================================================================================================
; Me, wrapper routines
;==========================================================================================================================================================

Declare   Editor_Look_Text(Gadget.i)                                                                ; 
Declare   Editor_Load_RTF_File(Gadget.i)                                                            ; 
Declare   Editor_Save_RTF_File(Gadget.i)                                                            ; 
Declare   Editor_SetColour(Gadget.i)                                                                ; 
Declare   Editor_SetFont(Gadget.i)                                                                  ; 
Declare   FontResize(Gadget.i, Direction.s)                                                         ; 

;==========================================================================================================================================================
; Minimising and maximising the program window
;==========================================================================================================================================================

Declare   HideProgramWindow()                                                                       ; Hide the program window
Declare   ShowProgramWindow()                                                                       ; Show the program window

;==========================================================================================================================================================
; Generic modules used by all programs
;==========================================================================================================================================================

Declare   ChangeIcon(mygadget.i, myrow.i, mycolumn.i, myicon.i)                                     ; Update each collumn of a ListIconGadget with a user defined icon as needed
Declare.s FormatField(InString.s, FieldLen.i)                                                       ; Format the passed string to the correct field length for printing/copying to clipboard etc
Declare.s GetShortcutText(Constant.i)                                                               ; Get the text of the associated shortcut constant
Declare.s KillQuote(Instring.s)                                                                     ; Kill double quotes in strings for display purposes
Declare   LastLine(Gadget.i, LineNumber.i)                                                          ; Go to the last line of a ListIconGadget
Declare.s RepQuote(Instring.s)                                                                      ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
Declare   RemoveBorders(GadgetConstant.i)                                                           ; Remove borders from various gadgets
Declare   StringFirstUpper(GadgetId.i)                                                              ; Convert the first character of a string to uppercase
Declare.s TextToXML(TextString.s)                                                                   ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
Declare.s XMLToText(XMLString.s)                                                                    ; Strip illegal characters from text strings

;==========================================================================================================================================================
; Database functions
;==========================================================================================================================================================

Declare.s CountRecords(TableField.s, TableName.s)                                                   ; Count the number of records in an SQLite database
Declare.s DatabaseLastInsertRowId()                                                                 ; Get the ID of the last inserted record
Declare.s LastRecord(TableName.s, TableField.s)                                                     ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
Declare   OpenSystemDatabase()                                                                      ; Try to open the system database and create missing tables

;==========================================================================================================================================================
; Custom include files
;==========================================================================================================================================================

Declare   BuildImageList(Gadget.i)                                                                  ; Rebuild the image list as it gets trashed by the clear command
Declare   CloseMyWindow(Window.i)                                                                   ; Fade the window out gently, close it and reset the mutex
Declare   MakeSureDirectoryPathExists(Directory.s)                                                  ; Need a unicode aware version of the API directory creator
Declare   SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = "")     ; Send messages and error reports to the fake status bar area
Declare   SetHoverIcons(Gadget.i, Image.i)                                                          ; Set the correct icons to the selected hoverable gadget
Declare   SortTitleStrings(HighlightString.s)                                                       ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
Declare   StatusBarButtonTip(ButtonItem.s)                                                          ; Show button tip in the statusbar area

;==========================================================================================================================================================
; Categories management
;==========================================================================================================================================================

Declare   AddCategory()                                                                             ; Add a new category to the database
Declare   CopyCategory()                                                                            ; Copy the current category to the clipboard
Declare   DeleteCategory()                                                                          ; Delete the selected category
Declare   EditCategory()                                                                            ; Edit the selected category
Declare   LoadCategories()                                                                          ; Load all the categories into the category bar
Declare   SaveCategory()                                                                            ; Save the changed category data to the database
Declare   ShowCategory()                                                                            ; Show the items that belong to a particular category
Declare   SortCategoryEntries()                                                                     ; Sort the category list after an add or edit

;==========================================================================================================================================================
; All data handling
;==========================================================================================================================================================

Declare   AddNewData()                                                                              ; Add a new serially item
Declare   CopyDataToClipboard()                                                                     ; Copy highlighted data to the system clipboard
Declare   DisplayTitleString(LineNumber.i, DisplayMode.s)                                           ; Handle all list display jobs from add, edit, list, import modes etc
Declare   DeleteCurrentData()                                                                       ; Mark the selected item as deleted
Declare   EditOldData()                                                                             ; Edit the old seriallyd ata
Declare   LockCurrentData()                                                                         ; Lock the current record against deletion and editing
Declare   MarkAsFavourite()                                                                         ; Mark this entry as a favourite item
Declare   SavePasswordData()                                                                        ; Save the new or edited PasswordMuncher data
Declare   SearchPasswords()                                                                         ; Show all the items in the database
Declare   ShowPasswordData()                                                                        ; Show the data string for PasswordMuncher on the screen
Declare   VacuumDeletedData()                                                                       ; Clean all deleted items from the database immediately

;==========================================================================================================================================================
; Export and import routines
;==========================================================================================================================================================

Declare   ExportDataItems()                                                                         ; Export data data to a standard XML file

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare   NewPassWordWindow()                                                                       ; Open the new password window
Declare   CheckNewPassWord()                                                                        ; Check that there is a new password
Declare   CheckConfirmPassWord()                                                                    ; Check that the old password and confirmation passwords match

;==========================================================================================================================================================
; Security password check on program startup
;==========================================================================================================================================================

Declare   StartPassWordWindow()                                                                     ; Show a password lock screen at program start
Declare   CheckStartUpPassWord()                                                                    ; Check the startup unlocking password

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare   EditpassWordWindow()                                                                      ; Open the edit password window
Declare   CheckpassWords()                                                                          ; Check that the old password and confirmation passwords match

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Declare   LockProgramWindow()                                                                       ; Lock the program window now
Declare   UnLockProgramWindow()                                                                     ; UnLock the program window now
Declare   CheckUnlockPassWord()                                                                     ; Check the unlocking password

;===========================================================================================================================================================
; Minimising and maximising the program window
;===========================================================================================================================================================

Declare   HideProgramWindow()                                                                       ; Hide the program window
Declare   ShowProgramWindow()                                                                       ; Show the program window

;==========================================================================================================================================================
; Various help and informational files
;==========================================================================================================================================================

;Declare  AboutProgram()                                                                             ; A quick 'about me' blurb
Declare   HelpForPasswords()                                                                        ; Show an RTF help file loaded into this window
Declare   KeysForPasswords()                                                                        ; Show a list of all the keyboard shortcuts

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 37
; FirstLine = 12
; EnableXP